#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "noise": 0,
    "mode": "single",
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    noise = int(cmdlinearg("noise"))
    mode = cmdlinearg("mode")
    
    leaves = random.sample(range(0, n), n-noise)
    edges = []
    used = set()
    used.add(leaves[0])

    for i in range(1, len(leaves)):
        if mode == "single":
            edges.append((leaves[0], leaves[i]))
            used.add(leaves[i])
        elif mode == "double":
            edges.append((leaves[(i+1)%2], leaves[i]))
            used.add(leaves[i])

    for i in range(0, n):
        if i not in used:
            j = leaves[random.randrange(0, len(leaves))]
            edges.append((i, j))
            leaves.append(i)
            used.add(i)
    
    print(n)
    for (u, v) in edges:
        print(u+1, v+1)
    
    
if __name__ == "__main__":
    main()
