#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    N = int(cmdlinearg("N"))
    remove = int(cmdlinearg("remove", 0))
    E = N * (N - 1) // 2 - remove
    print(N, E)
    eds = []
    for i in range(N):
        for j in range(i):
            eds.append((i + 1, j + 1))

    eds = random.sample(eds, E)
    for a, b in eds:
        print(a, b)
    
if __name__ == "__main__":
    main()
