#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "s": 10**6,
    "mode": "valid",
    "errors": 0,
    "letters": 26,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    s = int(cmdlinearg("s"))
    mode = cmdlinearg("mode")
    errors = int(cmdlinearg("errors"))
    letters = int(cmdlinearg("letters"))

    s -= errors
    alphabet = random.sample(list("abcdefghijklmnopqrstuvwxyz"), letters)
    sum_l = s // (2*n-2)

    words = []
    grid = []

    if mode == "valid" or mode == "uneven" or mode == "empty":
        r = sum_l
        if mode == "uneven":
            r = sum_l // 2
        lengths = random.sample(range(1, r), n-1)

        if mode == "empty":
            i = random.randrange(1, n-1)
            lengths[i] = lengths[i-1]

        lengths.append(sum_l)
        lengths.sort()
        prev = 0
        for i in range(n):
            (prev, lengths[i]) = (lengths[i], lengths[i]-prev)
        
        for i in range(n):
            word = []
            for _ in range(lengths[i]):
                word.append(alphabet[random.randrange(0, letters)])
            words.append("".join(word))
        
        cells = []

        for i in range(n):
            row = []
            for j in range(n):
                if i == j:
                    row.append("*")
                else:
                    cells.append((i, j))
                    row.append(words[i]+words[j])
            grid.append(row)
        
        for _ in range(errors):
            (i, j) = cells[random.randrange(0, len(cells))]
            r = random.randrange(0, len(grid[i][j]))
            new_str = []
            for x in range(len(grid[i][j])):
                if x == r:
                    new_str.append(alphabet[random.randrange(0, letters)])
                    if random.randint(0, 1) == 1:
                        # insert letter
                        new_str.append(grid[i][j][x])
                else:
                    new_str.append(grid[i][j][x])
            grid[i][j] = "".join(new_str)

    elif mode == "random":
        lengths = random.sample(range(1, s), n*n-n)
        lengths.sort()
        prev = 0
        for i in range(n*n-n):
            (prev, lengths[i]) = (lengths[i], lengths[i]-prev)
        x = 0
        for i in range(n):
            row = []
            for j in range(n):
                if i == j:
                    row.append("*")
                else:
                    row.append("".join([alphabet[random.randrange(0, letters)] for _ in range(lengths[x])]))
                    x += 1
            grid.append(row)
                    
    
    print(n)
    for i in range(n):
        print(*grid[i])
        
    
    
    
    
if __name__ == "__main__":
    main()
