#!/usr/bin/python3

import sys
import random

def cmdlinearg(name, default=None):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    assert default is not None
    return default

def main():
    random.seed(int(sys.argv[-1]))
    N = int(cmdlinearg("N"))
    maxh = int(cmdlinearg("maxh", 318 * 10**9))
    print(N)
    print(*[random.randint(0, maxh) for _ in range(N)])
    
if __name__ == "__main__":
    main()
